.menu-section {
  --menu-search-color: var(--tertiary-text-color);
  --menu-filter-bg-color: var(--popup-bg-color);
  --menu-cart-icon-color: var(--primary-rounded-button-text-color);
  --menu-cart-icon-bg-color: var(--primary-rounded-button-bg-color);
  --menu-dialog-bg-color: var(--popup-bg-color);
  --sold-out-color: var(--error-color);
  --original-price-sale-color: var(--tertiary-text-color);
  --sale-color: var(--primary-text-color);
  --variation-soldout-bg-color: linear-gradient(to top right, transparent calc(50% - 1px), var(--black-100), transparent calc(50% + 1px));
  --max-quantity-color: var(--error-color);
}

html:not(:has(.header-section:focus-within)) {
  scroll-behavior: smooth;
  scroll-padding-top: var(--header-height);
}

body:has(.header-section.stuck.not-scrolling-up) .menu-filter-container {
  top: 0;
}

body:has(.menu-result-dialog[open]) {
  overflow: hidden;
}

.menu-section .container {
  row-gap: 2rem;

  @media (width >= 56.25rem) {
    row-gap: 3rem;
    grid-template-rows: auto 1fr;
  }
}

.menu-title-container {
  display: flex;
  flex-direction: column;
  row-gap: 1rem;

  @media (width >= 56.25rem) {
    grid-column: 5 / -1;
    grid-row: 1;
  }
}

.menu-title {
  text-align: center;

  @media (width >= 56.25rem) {
    text-align: left;
  }
}

.menu-fulfillment-container {
  display: flex;
  gap: 1rem;
  align-items: center;
  flex-wrap: wrap;
  justify-content: center;

  @media (width >= 56.25rem) {
    justify-content: start;
  }
}

.menu-fulfillment-type {
  display: grid;
  grid-template-columns: 1fr 1fr;
  padding: 0.25rem;
  width: fit-content;
  border-radius: 2rem;
  border: var(--border-secondary);
}

.menu-fulfillment-label {
  width: 100%;
  text-transform: none;
  cursor: pointer;
  border-radius: 2rem;
  padding: 0.5rem;
  text-transform: none;

  &[for="menu-fulfillment-type-pickup"]:before {
    mask-image: url("../../assets/icons/pickup.svg");
    display: block;
  }

  &[for="menu-fulfillment-type-shipping"]:before {
    mask-image: url("../../assets/icons/bicycle.svg");
    display: block;
  }
}

.menu-fulfillment-input:checked + .menu-fulfillment-label {
  background-color: var(--primary-button-bg-color);
  color: var(--primary-button-text-color);
}

.menu-fulfillment-input:focus-visible + .menu-fulfillment-label {
  outline: 2px solid var(--black-100);
  outline-offset: 5px;
}

.menu-shipping-postal-code {
  display: flex;
  column-gap: 0.5rem;
  align-items: center;
  padding: 0.5rem;
  border-radius: 2rem;
  border: var(--border-secondary);
  text-transform: uppercase;
  width: fit-content;
  transition: border-color 0.3s;

  &:hover {
    border-color: currentColor;
  }

  &:empty {
    display: none;
  }

  &:before {
    mask-image: url("../../assets/icons/route.svg");
    display: block;
  }
}

.menu-filter-container {
  display: flex;
  position: sticky;
  column-gap: 1rem;
  top: var(--header-height);
  height: fit-content;
  background-color: var(--menu-filter-bg-color);
  z-index: 1;
  transition: top 0.3s;

  @media (width >= 56.25rem) {
    grid-column: 1 / 4;
    grid-row: 1 / -1;
    padding-top: 1rem;
    flex-direction: column;
    row-gap: 1rem;
    background-color: unset;
    z-index: unset;
  }
}

.menu-filters {
  display: flex;
  column-gap: 0.5rem;
  overflow-x: auto;
  scroll-behavior: smooth;
  scroll-snap-type: x mandatory;
  overscroll-behavior-x: contain;
  scrollbar-width: thin;
  padding-block: 0.5rem;

  @media (width >= 56.25rem) {
    flex-direction: column;
    row-gap: 0.5rem;
    padding-block: 0;
    overflow-x: initial;
    width: 100%;
  }

  @supports (animation-timeline: scroll()) {
    @media (width < 56.25rem) {
      mask: linear-gradient(
        to right,
        var(--white-100) calc(100% - var(--right-scroll-fade)),
        transparent
      );
      animation: scroll-fade-right linear;
      animation-timeline: --menu-filters-scroll-fade;
      scroll-timeline: --menu-filters-scroll-fade inline;
    } 
  }
}

.menu-filter-container:has(.menu-search-toggle[aria-expanded="true"]) .menu-filters {
  @media (width < 56.25rem) {
    display: none;
  }
}

.menu-search-controls {
  display: flex;
  column-gap: 0.5rem;
  align-items: center;
  padding-block: 0.5rem;
  height: fit-content;

  &:has(.menu-search-toggle[aria-expanded="true"]) :is(.menu-search-label, .menu-search-close) {
    display: flex;
  }

  &:has(.menu-search-toggle[aria-expanded="true"]) {
    width: 100%;
  }

  @media (width >= 56.25rem) {
    padding-block: 0;
  }
}

.menu-search-label {
  display: none;
  width: 100%;
  column-gap: 1rem;
  align-items: center;
  border: var(--border-secondary);
  padding: 0.5rem;

  &:before {
    mask-image: url("../../assets/icons/search.svg");
    background-color: var(--menu-search-color);
    display: block;
  }

  &:has(.menu-search-input:focus-visible) {
    outline: 2px solid var(--black-100);
    outline-offset: 2px;
  }

  @media (width >= 56.25rem) {
    display: flex;
  }
}

.menu-search-toggle {
  display: flex;
  padding: 0.5rem;
  border: var(--border-secondary);
  
  &::after {
    mask-image: url("../../assets/icons/search.svg");
    display: block;
    background-color: var(--menu-search-color);
  }

  &[aria-expanded="true"] {
    display: none;
  }

  @media (width >= 56.25rem) {
    display: none;
  }
}

.menu-search-close {
  display: none;
  padding: 0.5rem;
  border: var(--border-secondary);
  
  &::after {
    mask-image: url("../../assets/icons/close.svg");
    display: block;
    background-color: var(--menu-search-color);
  }

  @media (width >= 56.25rem) {
    display: none;
  }
}

.menu-search-input {
  width: 100%;
  text-align: left;
  border: none;

  &::placeholder {
    color: var(--menu-search-color);
  }

  &:focus {
    outline: none;
  }

  &::-webkit-search-cancel-button,
  &::-webkit-search-decoration,
  &::-webkit-search-results-button,
  &::-webkit-search-results-decoration {
    display: none;
  }
}

.menu-filter {
  scroll-snap-stop: always;
  scroll-snap-align: start;
  min-width: fit-content;
}

.menu-filter-button {
  display: flex;
  width: 100%;
  padding: 0.5rem;
  text-transform: initial;
  justify-content: start;
  border: var(--border-secondary);

  &[aria-current="true"] {
    background-color: var(--primary-button-bg-color);
    color: var(--primary-button-text-color);
    border: var(--primary-button-bg-color);
  }
}

.menu-results-container {
  display: flex;
  flex-direction: column;
  row-gap: 3rem;

  @media (width >= 56.25rem) {
    grid-column: 5 / -1;
    grid-row: 2;
  }
}

.menu-result {
  display: flex;
  flex-direction: column;
  row-gap: 1rem;

  &.popular.hidden {
    display: none;
  }

  &:not(:has(.menu-result-item:not(.hidden))) {
    display: none;
  }
}

.menu-result-title {
  text-align: left;

  &.hidden {
    display: none;
  }
}

.menu-result-list {
  display: grid;
  row-gap: 1.5rem;

  @media (width >= 56.25rem) {
    grid-template-columns: 1fr 1fr;
    gap: 1.5rem;
  }

  @supports (animation-timeline: scroll()) {
    @media (width < 56.25rem) {
      mask: linear-gradient(
        to right,
        var(--white-100) calc(100% - var(--right-scroll-fade)),
        transparent
      );
      animation: scroll-fade-right linear;
      animation-timeline: --menu-result-list-scroll-fade;
      scroll-timeline: --menu-result-list-scroll-fade inline;
    } 
  }
}

.menu-result-item.hidden {
  display: none;
}

.menu-result-link {
  display: grid;
  grid-template-columns: minmax(0, 1fr) minmax(0, 1fr);
  border: var(--border-secondary);
  border-radius: 0 1rem 1rem 0;
  height: 100%;
}

.menu-result-info {
  display: flex;
  flex-direction: column;
  row-gap: 0.5rem;
  padding: 1rem;
  text-align: left;
  height: 100%;

  &:hover .menu-result-name {
    text-decoration-color: currentColor;
  }
}

.menu-result-image-container {
  display: flex;
  border-radius: 0 1rem 1rem 0;
  position: relative;
  overflow: hidden;
  justify-content: center;
  justify-self: end;
  max-height: 14rem;
  align-self: center;
}

.menu-result-image-container .cart-icon {
  position: absolute;
  bottom: 0.5rem;
  right: 0.5rem;
  background-color: var(--menu-cart-icon-bg-color);
  padding: 0.5rem;
  border-radius: 0.5rem;
  pointer-events: none;

  &::after {
    display: block;
    mask-image: url("../../assets/icons/cart.svg");
    background-color: var(--menu-cart-icon-color);
  }
}

.menu-result-image {
  object-fit: cover;
  aspect-ratio: 1 / 1;
  transition: scale 0.3s;

  &:hover {
    scale: 1.1;
  }
}

.menu-result-name {
  display: -webkit-box;
  -webkit-line-clamp: 2;
  -webkit-box-orient: vertical;  
  -moz-line-clamp: 2;
  -moz-box-orient: vertical;
  line-clamp: 2;
  box-orient: vertical;
  overflow: hidden;
  text-align: left;
  text-decoration: underline;
  text-decoration-color: transparent;
  text-underline-offset: 0.25rem;
  transition: text-decoration-color 0.3s;
}

.menu-result-description {
  display: -webkit-box;
  -webkit-line-clamp: 4;
  -webkit-box-orient: vertical;  
  -moz-line-clamp: 4;
  -moz-box-orient: vertical;
  line-clamp: 4;
  box-orient: vertical;
  overflow: hidden;
}

.menu-result-price {
  display: flex;
  gap: 0.5rem;
  margin-top: auto;
  flex-wrap: wrap;

  &:has(.menu-result-sale-price:not(:empty)) .menu-result-original-price {
    text-decoration: line-through;
    color: var(--original-price-sale-color);
  }
}

.menu-result-sale-price {
  color: var(--sale-color);
}

.menu-result-item .sold-out-text {
  display: none;
  color: var(--sold-out-color);
  text-align: left;

  &.visible {
    display: block;
    color: var(--sold-out-color);
  }
}

.menu-result-slider {
  position: relative;
  isolation: isolate;
}

.menu-result-slider .scroll-button {
  position: absolute;
  top: 40%;
  transform: translateY(-50%);
  z-index: 1;

  &.hidden {
    display: none;
  }

  &.left {
    left: -1rem;

    &:after {
      display: block;
      mask-image: url('../../assets/icons/angle-left.svg');
    }
  }

  &.right {
    right: -1rem;

    &:after {
      display: block;
      mask-image: url('../../assets/icons/angle-right.svg');
    }
  }
}

.menu-result-slider .menu-result-list {
  display: flex;
  overflow-x: auto;
  scroll-behavior: smooth;
  scroll-snap-type: x mandatory;
  overscroll-behavior-x: contain;
  scrollbar-width: none;
  column-gap: 2rem;
}

.menu-result-slider .menu-result-item {
  flex: 0 0 60%;
  scroll-snap-stop: always;
  scroll-snap-align: start;
  position: relative;
  max-width: 15rem;

  @media (width >= 37.5rem) {
    flex: 0 0 calc(50% - 1.125rem);
  }

  @media (width >= 56.25rem) {
    flex: 0 0 calc(33.33% - 1.5rem);
  }

  @media (width >= 75rem) {
    flex: 0 0 calc(25% - 1.7rem);
  }
}

.menu-result-slider .menu-result-link {
  display: flex;
  row-gap: 0.5rem;
  flex-direction: column;
  justify-content: center;
  height: 100%;
  max-height: fit-content;
  border: none;
}

.menu-result-slider .menu-result-name:hover {
  text-decoration-color: currentColor;
}

.menu-result-slider .menu-result-image-container {
  border-radius: 1rem;
  height: auto;
}

.menu-result-slider .menu-result-image {
  max-width: 100%;
}

.menu-section-no-results {
  display: none;

  &.visible {
    display: block;
  }
}

.menu-result-dialog {
  width: 40rem;
  max-width: 90%;
  margin: auto;
  background-color: var(--menu-dialog-bg-color);
  border: var(--border-primary);

  &::backdrop {
    background-color: var(--backdrop-bg-color);
  }

  @supports (transition-behavior: allow-discrete) {
    transition: opacity 0.3s, transform 0.3s;
    transition-behavior: allow-discrete;
    opacity: 0;
    transform: scale(0);
  }

  &[open] {
    @supports (transition-behavior: allow-discrete) {
      opacity: 1;
      transform: scale(1);

      @starting-style {
        opacity: 0;
        transform: scale(0);
      }
    }
  }
}

.menu-result-dialog-close {
  justify-content: flex-end;
  position: absolute;
  top: 1rem;
  right: 1rem;

  &:after {
    display: block;
    mask-image: url('../../assets/icons/close.svg');
  }
}

.menu-result-dialog-form {
  display: flex;
  flex-direction: column;
  row-gap: 1rem;
  max-height: 90vh;
  max-height: 90dvh;
  overflow-y: auto;
  scrollbar-width: thin;

  &[data-soldout="true"] :is(.multivariation-group, .add-to-cart-button, .product-quantity-container, .product-comment-label) {
    display: none;
  }

  &[data-soldout="true"] .sold-out-button {
    display: flex;
  }

  &[data-soldout="true"] .menu-result-dialog-content hgroup {
    border-bottom: none;
  }

  &[aria-busy="true"]:has([id^="#product-stock"], .multivariation-data[data-stock="true"]) hgroup {
    position: relative;

    &:after {
      display: block;
      mask-image: url('../../assets/icons/loader.svg');
      animation: spin 1s linear infinite;
      left: 50%;
      translate: -50% 0;
      position: absolute;
      top: calc(100% + 3rem);
    }
  }

  &[aria-busy="true"]:has([id^="#product-stock"], .multivariation-data[data-stock="true"]) :is(.menu-result-dialog-price, fieldset, .product-comment-label) {
    visibility: hidden;
  }
}

body:has(.cart-items[aria-busy="true"]) .add-to-cart-button {
  pointer-events: none;
  opacity: 0.5;
}

.menu-result-dialog-content {
  display: flex;
  flex-direction: column;
  row-gap: 2rem;
  padding-inline: 1rem;
}

.menu-result-dialog-content hgroup {
  padding-bottom: 2rem;
  border-bottom: var(--border-secondary);
}

.menu-result-dialog-image-container {
  display: flex;
}

.menu-result-dialog-image {
  width: 100%;
  height: 15rem;
  object-fit: cover;
}

.menu-result-dialog-title {
  text-align: left;
}

.menu-result-dialog .sold-out-button {
  display: none;
  pointer-events: none;
  width: 100%;
}

.menu-result-dialog-price {
  text-align: left;

  &:has(.menu-result-dialog-sale-price) {
    display: flex;
    column-gap: 0.5rem;
  }

  &:has(.menu-result-dialog-sale-price:not(:empty)) .menu-result-dialog-original-price {
    text-decoration: line-through;
    color: var(--original-price-sale-color);
  }
}

.menu-result-dialog-sale-price:empty {
  display: none;
}

.menu-result-dialog:has(.multivariation-input:checked) .menu-result-dialog-price-text {
  display: none;
}

.product-quantity-container {
  display: flex;
  flex-direction: column;
  row-gap: 0.5rem;
  width: fit-content;
  height: stretch;
  height: -webkit-fill-available;
}

.product-quantity-title {
  text-align: left;
  cursor: text;
}

.product-quantity-controls {
  display: flex;
  align-items: center;
  border: var(--border-secondary);
  width: fit-content;
  height: 100%;
}

.product-quantity-input {
  text-align: center;
  border: none;
  appearance: textfield;
  height: 100%;
  width: 3ch;

  &::-webkit-inner-spin-button,
  &::-webkit-outer-spin-button {
    -webkit-appearance: none;
    margin: 0;
  }
}

.product-quantity-decrease,
.product-quantity-increase {
  padding: 0.5rem 1rem;
}

.product-quantity-container .max-quantity-message {
  color: var(--max-quantity-color);

  &.hidden {
    display: none;
  }
}

.multivariation-group {
  border: none;
  padding: 0;
  margin: 0;
  display: flex;
  flex-wrap: wrap;
  gap: 0.5rem;
}

.multivariation-title {
  padding: 0;
  text-align: left;
  margin-bottom: 0.5rem;
}

.multivariation-input:checked + .multivariation-button {
  background-color: var(--primary-button-bg-color);
  color: var(--primary-button-text-color);
}

.multivariation-input:focus-visible + .multivariation-button {
  outline: 2px solid var(--black-100);
  outline-offset: 5px;
}

.multivariation-input:disabled + .multivariation-button {
  opacity: 0.5;
  pointer-events: none;
  position: relative;

  &:after {
    content: "";
    width: 100%;
    height: 100%;
    position: absolute;
    top: 0;
    left: 0;
    background: var(--variation-soldout-bg-color);
  }
}

.multivariation-button {
  cursor: pointer;
  padding: 0.5rem 1rem;
  border: var(--border-transparent);
  background-color: var(--tertiary-button-bg-color);
  width: fit-content;
  text-transform: none;

  &:hover {
    border: var(--border-primary);
  }
}

.menu-result-dialog .button-container {
  display: flex;
  column-gap: 1rem;
  width: 100%;
  position: sticky;
  bottom: 0;
  background-color: var(--menu-dialog-bg-color);
  border-top: var(--border-secondary);
  padding: 1rem;
  flex-wrap: wrap;
}

.add-to-cart-button {
  column-gap: 1rem;
  justify-content: space-between;
  flex: 1 1 auto;
  width: fit-content;
  position: relative;

  &[aria-busy="true"] span {
    visibility: hidden;
  }

  &[aria-busy="true"]:after {
    display: block;
    mask-image: url('../../assets/icons/loader.svg');
    animation: spin 1s linear infinite;
    position: absolute;
    left: 50%;
    translate: -50% 0;
  }
  
  &:disabled {
    opacity: 0.5;
    pointer-events: none;
  }
}

.product-comment-label {
  display: flex;
  flex-direction: column;
  row-gap: 0.5rem;
  text-align: left;
}

.product-comment-input {
  resize: vertical;
  field-sizing: content;
  min-height: 3lh;
  box-sizing: content-box;
  padding: 0.75rem;
  border: var(--border-secondary);
}